﻿using System;
using System.Runtime.InteropServices;

using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;

using System.Configuration;
using System.Data;
using System.Web.UI.WebControls;
using Microsoft.SharePoint.Utilities;
using System.Web.UI;


namespace ParentChildListRelationship
{
    // TODO: Replace, as needed, "TextField" with some other class derived from Microsoft.SharePoint.WebControls.BaseFieldControl.
    [CLSCompliant(false)]
    [Guid("7e0e1a5f-27cd-474b-8f73-912260f941e9")]
    public class ParentChildrenGridFieldControl : TextField
    {
        private SPGridView spGrid;
        int NumOfChildren = 0;

        protected override void CreateChildControls()
        {
            base.CreateChildControls();

            this.spGrid = new SPGridView();

            if (this.ControlMode == SPControlMode.Display ||
                this.ControlMode == SPControlMode.Edit ||
                this.ControlMode == SPControlMode.New)
            {
                SPWeb web = SPContext.GetContext(this.Context).Web;
                SPList childrenList = null;

                try
                {
                    childrenList = web.Lists["My Sub-Tabs"];
                }
                catch
                {
                    throw new ConfigurationErrorsException(@"Please Create My Sub-Tabs list at the site.");
                }

                SPView view;
                try
                {
                    view = childrenList.Views["All Items"];
                }
                catch
                {
                    view = childrenList.DefaultView;
                }
                SPQuery query = new SPQuery(view);

                query.Query = string.Format(@"
                <Where>
                    <Eq>
                        <FieldRef Name='ParentTab' LookupId='true' />
                        <Value Type='Integer'>{0}</Value>
                    </Eq>
                 </Where>", this.Item.ID.ToString());

                // <OrderBy>
                //   <FieldRef Name='Order' />
                // </OrderBy>

                SPViewFieldCollection viewFields = view.ViewFields;
                SPFolder folder = childrenList.RootFolder;
                DataTable dt = childrenList.GetItems(query).GetDataTable();
                if (dt != null)
                {
                    NumOfChildren = dt.Rows.Count;
                }

                DoDataBind(childrenList, dt, viewFields, folder);

                base.Controls.Add(spGrid);
            }
        }

        void DoDataBind(SPList list, DataTable dt, SPViewFieldCollection viewFields, SPFolder folder)
        {
            spGrid.DataSource = dt;

            spGrid.AutoGenerateColumns = false;
            spGrid.Columns.Clear();

            foreach (String internalName in viewFields)
            {
                switch (internalName.ToLower())
                {
                    case "attachments":
                        continue;

                    #region docicon
                    /*case "docicon":
                        {
                            HyperLinkField field = new HyperLinkField();
                            field.DataTextField = internalName;
                            field.SortExpression = internalName;
                            field.DataTextFormatString = "<image src='/_layouts/images/ic{0}.gif' border=0/>";
                            field.DataNavigateUrlFields = new string[] { "LinkFileName" };
                            field.DataNavigateUrlFormatString = folder.ServerRelativeUrl + "/{0}";
                            field.HeaderText = "Type";
                            field.Target = "_blank";
                            spGrid.Columns.Add(field);
                        }
                        break;
                    case "linkfilename":
                        {
                            HyperLinkField field = new HyperLinkField();
                            field.DataTextField = internalName;
                            field.SortExpression = internalName;
                            field.DataTextFormatString = "{0}";
                            field.DataNavigateUrlFields = new string[] { "LinkFileName" };
                            field.DataNavigateUrlFormatString = folder.ServerRelativeUrl + "/{0}";
                            field.HeaderText = "Name";
                            field.Target = "_blank";
                            spGrid.Columns.Add(field);
                        }
                        break;
                     */
                    #endregion

                    default:
                        {
                            BoundField bf = new BoundField();
                            bf.DataField = internalName;
                            bf.SortExpression = internalName;
                            //f.DataFormatString = "<A onfocus=OnLink(this) onclick='MyGoToLink(this);return false;' href='" + list.RootFolder.ServerRelativeUrl + "/Forms/DispForm.aspx?ID={0}' target='_self'>view</a>";
                            bf.HeaderText = internalName;
                            //f.Target = "_blank";
                            spGrid.Columns.Add(bf);
                        }
                        break;
                }
            }

            HyperLinkField f = new HyperLinkField();
            f.DataTextField = "ID";
            f.SortExpression = "ID";
            f.HeaderText = "View";
            f.DataTextField = "ID";
            f.DataTextFormatString = "<IMG alt=\"View Doc Properties\" src=\"/_layouts/images/edititem.gif\" border=0>";
            f.DataNavigateUrlFormatString = list.RootFolder.ServerRelativeUrl + "/DispForm.aspx?ID={0}&Source=" + SPEncode.UrlEncode(this.Page.Request.Url.ToString()); 
            f.DataNavigateUrlFields = new string[] { "ID" };
            //f.Target = "_blank";
            spGrid.Columns.Add(f);
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (!this.Page.IsPostBack)
            {
                spGrid.DataBind();
            }
        }

        public override void UpdateFieldValueInItem()
        {
            this.EnsureChildControls();

            try
            {
                //this.Value = this.listBox.SelectedValue;
                this.Value = NumOfChildren;
                this.ItemFieldValue = this.Value;
            }
            catch (Exception)
            {
                ;
            }
        }

        protected override void Render(HtmlTextWriter output)
        {
            this.spGrid.RenderControl(output);
        }
    }
}
